
data = [
];

// object to hold histogram values based on input data
var pslFrequency =[
  {
    "psl":"TDB",
    "count" : 0
  },
  {
    "psl":"TDN",
    "count" : 0
  },
  {
    "psl":"TEB",
    "count" : 0
  },
  {
    "psl":"TEN",
    "count" : 0
  },
  {
    "psl":"SDB",
    "count" : 0
  },
  {
    "psl":"SDN",
    "count" : 0
  },
  {
    "psl":"SEB",
    "count" : 0
  },
  {
    "psl":"SEN",
    "count" : 0
  },

]


function AddData() {

  //replace these hardcoded values with Document.getElementById() or querySelector()
  //example implementation:
  //var plantType = document.querySelector('input[name="plantType"]:checked').value;
  
  var plantType = "shrub";
  var seasonality = "evergreen";
  var leafType = "broadleaf";
  var dateTime = new Date();
  var location = "UCSB";
  var nitrogen = 10;
  var carbon = 9;
  var leafArea = 8;

  var currentVal = {
    plantType: plantType,
    seasonality: seasonality,
    leafType: leafType,
    //variable that represents aggregated categorizations
    psl: plantType[0].toUpperCase() + seasonality[0].toUpperCase() + leafType[0].toUpperCase(),
    dateTime: dateTime,
    location: location,
    nitrogen: nitrogen,
    carbon: carbon,
    leafArea: leafArea,
    close: 0
  }

  data.push(currentVal);
  ReDrawChart();
}

/*
normally AddData should be called when your form is populated with new data.
so that data[] array can be populated with new object.
here we call AddData to push the initial dummy values to data array.
*/
AddData();


/*
This function draws the histogram on chart object.
you don't need to change this function.
*/
function ReDrawChart() {

  var byPSL = d3.nest()
    .key(function (d) { return d.psl; })
    .entries(data);


    for ( psl in byPSL) {
      for(i in pslFrequency ){
        if(pslFrequency[i].psl ===  byPSL[psl].key){
          pslFrequency[i].count =  byPSL[psl].values.length
        }
      }
    }

  var carbAvg = 0;
  var nitrAvg =0;
  var leafAvg = 0;
  if (data.length>0){
    carbAvg = d3.mean(data, function (d) { return d.carbon; });
    nitrAvg = d3.mean(data, function (d) { return d.nitrogen; });
    leafAvg = d3.mean(data, function (d) { return d.leafArea; });
  }



  var margin = { left: 50, right: 50, top: 20, bottom: 30 };

  var w = document.getElementById("chart").parentElement.clientWidth;
  var width = w - margin.left - margin.right;
  var height = 300 - margin.top - margin.bottom;

  var xNudge = margin.left;
  var yNudge = margin.top;
  var max = d3.max(pslFrequency, function (d) { return d.count });
  var minDate = d3.min(data, function (d) { return new Date(d.dateTime) });
  var maxDate = d3.max(data, function (d) { return new Date(d.dateTime) });

    //here we set the summary values on the DOM elements
    document.getElementById("carbonAvg").value = carbAvg;
    document.getElementById("nitrogenAvg").value = nitrAvg;
    document.getElementById("leafAreaAvg").value = leafAvg;

  if (minDate !== undefined) {
    document.getElementById("minDateTime").value = minDate.toLocaleDateString() + ' ' + minDate.toLocaleTimeString();
    document.getElementById("maxDateTime").value = maxDate.toLocaleDateString() + ' ' + maxDate.toLocaleTimeString();
  }

  pslFrequency.forEach(function(d) {
    d.count = +d.count;
  });


  var x = d3.scaleBand()
    .range([0, width])
    .padding(0.1);

  var y  = d3.scaleLinear()
  .range([height, 0]);

 
  
  x.domain(pslFrequency.map(function (d) {
    return d.psl; }));
    
  if(max>0){
    y.domain([0, d3.max(pslFrequency, function (d) { 
      return d.count; })]);
  }

  var yAxis = d3.axisLeft(y).tickFormat(d3.format('d')).ticks(Math.min(max,10));
  var xAxis = d3.axisBottom(x).ticks(10);

  d3.select('#chart').node().innerHTML = "";
  var svg = d3.select('#chart').append("svg").attr("id", "svg");
  var chartGroup = svg.append("g").attr("class", "chartGroup").attr("transform", "translate(" + xNudge + "," + yNudge + ")");

  chartGroup
    .selectAll(".bar")
    .data(pslFrequency)
    .enter().append("rect")
    .attr("class", "bar")
    .attr("x", function (d) {
      return x(d.psl); })
    .attr("width", x.bandwidth())
    .attr("y", function (d) {
      return y(d.count); })
    .attr("height", function (d) { 
      return height - y(d.count);});

  // add the x Axis
  chartGroup.append("g")
    .attr("transform", "translate(0," + height + ")")
    .call(xAxis);

  // add the y Axis
  chartGroup.append("g")
    .call(yAxis);
}

